Index: kernel/generic/include/proc/program.h
===================================================================
--- kernel/generic/include/proc/program.h	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/generic/include/proc/program.h	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -50,5 +50,4 @@
 	struct task *task;           /**< Program task */
 	struct thread *main_thread;  /**< Program main thread */
-	unsigned int loader_status;  /**< Binary loader error status */
 } program_t;
 
Index: kernel/generic/include/proc/thread.h
===================================================================
--- kernel/generic/include/proc/thread.h	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/generic/include/proc/thread.h	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -54,13 +54,21 @@
 
 /* Thread flags */
-typedef enum {
-	THREAD_FLAG_NONE = 0,
-	/** Thread executes in user space. */
-	THREAD_FLAG_USPACE = (1 << 0),
-	/** Thread will be attached by the caller. */
-	THREAD_FLAG_NOATTACH = (1 << 1),
-	/** Thread accounting doesn't affect accumulated task accounting. */
-	THREAD_FLAG_UNCOUNTED = (1 << 2)
-} thread_flags_t;
+
+/** Thread cannot be migrated to another CPU.
+ *
+ * When using this flag, the caller must set cpu in the thread_t
+ * structure manually before calling thread_ready (even on uniprocessor).
+ *
+ */
+#define THREAD_FLAG_WIRED  (1 << 0)
+
+/** Thread was migrated to another CPU and has not run yet. */
+#define THREAD_FLAG_STOLEN  (1 << 1)
+
+/** Thread executes in userspace. */
+#define THREAD_FLAG_USPACE  (1 << 2)
+
+/** Thread will be attached by the caller. */
+#define THREAD_FLAG_NOATTACH  (1 << 3)
 
 /** Thread structure. There is one per thread. */
@@ -139,5 +147,5 @@
 	
 	fpu_context_t *saved_fpu_context;
-	bool fpu_context_exists;
+	int fpu_context_exists;
 	
 	/*
@@ -146,22 +154,18 @@
 	 * thread. This disables migration.
 	 */
-	bool fpu_context_engaged;
+	int fpu_context_engaged;
 	
 	/* The thread will not be migrated if nomigrate is non-zero. */
-	unsigned int nomigrate;
-	
-	/** Thread state. */
+	int nomigrate;
+	
+	/** Thread's state. */
 	state_t state;
-	
-	/** Thread CPU. */
+	/** Thread's flags. */
+	unsigned int flags;
+	
+	/** Thread's CPU. */
 	cpu_t *cpu;
 	/** Containing task. */
 	task_t *task;
-	/** Thread is wired to CPU. */
-	bool wired;
-	/** Thread was migrated to another CPU and has not run yet. */
-	bool stolen;
-	/** Thread is executed in user space. */
-	bool uspace;
 	
 	/** Ticks before preemption. */
@@ -212,6 +216,5 @@
 extern void thread_init(void);
 extern thread_t *thread_create(void (*)(void *), void *, task_t *,
-    thread_flags_t, const char *);
-extern void thread_wire(thread_t *, cpu_t *);
+    unsigned int, const char *, bool);
 extern void thread_attach(thread_t *, task_t *);
 extern void thread_ready(thread_t *);
Index: kernel/generic/src/adt/btree.c
===================================================================
--- kernel/generic/src/adt/btree.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/generic/src/adt/btree.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -71,5 +71,5 @@
 void btree_init(void)
 {
-	btree_node_slab = slab_cache_create("btree_node_t",
+	btree_node_slab = slab_cache_create("btree_node_slab",
 	    sizeof(btree_node_t), 0, NULL, NULL, SLAB_CACHE_MAGDEFERRED);
 }
Index: kernel/generic/src/console/cmd.c
===================================================================
--- kernel/generic/src/console/cmd.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/generic/src/console/cmd.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -724,7 +724,11 @@
 		thread_t *thread;
 		if ((thread = thread_create((void (*)(void *)) cmd_call0,
-		    (void *) argv, TASK, THREAD_FLAG_NONE, "call0"))) {
+		    (void *) argv, TASK, THREAD_FLAG_WIRED, "call0", false))) {
+			irq_spinlock_lock(&thread->lock, true);
+			thread->cpu = &cpus[i];
+			irq_spinlock_unlock(&thread->lock, true);
+			
 			printf("cpu%u: ", i);
-			thread_wire(thread, &cpus[i]);
+			
 			thread_ready(thread);
 			thread_join(thread);
Index: kernel/generic/src/ipc/ipc.c
===================================================================
--- kernel/generic/src/ipc/ipc.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/generic/src/ipc/ipc.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -670,7 +670,7 @@
 void ipc_init(void)
 {
-	ipc_call_slab = slab_cache_create("call_t", sizeof(call_t), 0, NULL,
+	ipc_call_slab = slab_cache_create("ipc_call", sizeof(call_t), 0, NULL,
 	    NULL, 0);
-	ipc_answerbox_slab = slab_cache_create("answerbox_t",
+	ipc_answerbox_slab = slab_cache_create("ipc_answerbox",
 	    sizeof(answerbox_t), 0, NULL, NULL, 0);
 }
Index: kernel/generic/src/ipc/kbox.c
===================================================================
--- kernel/generic/src/ipc/kbox.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/generic/src/ipc/kbox.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -244,6 +244,6 @@
 	
 	/* Create a kbox thread */
-	thread_t *kb_thread = thread_create(kbox_thread_proc, NULL, task,
-	    THREAD_FLAG_NONE, "kbox");
+	thread_t *kb_thread = thread_create(kbox_thread_proc, NULL, task, 0,
+	    "kbox", false);
 	if (!kb_thread) {
 		mutex_unlock(&task->kb.cleanup_lock);
Index: kernel/generic/src/ipc/sysipc.c
===================================================================
--- kernel/generic/src/ipc/sysipc.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/generic/src/ipc/sysipc.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -597,5 +597,5 @@
 	if (IPC_GET_IMETHOD(call->data) == IPC_M_CONNECT_TO_ME) {
 		int phoneid = phone_alloc(TASK);
-		if (phoneid < 0) {  /* Failed to allocate phone */
+		if (phoneid < 0) { /* Failed to allocate phone */
 			IPC_SET_RETVAL(call->data, ELIMIT);
 			ipc_answer(box, call);
@@ -883,7 +883,7 @@
 	
 	/*
-	 * User space is not allowed to change interface and method of system
+	 * Userspace is not allowed to change interface and method of system
 	 * methods on forward, allow changing ARG1, ARG2, ARG3 and ARG4 by
-	 * means of imethod, arg1, arg2 and arg3.
+	 * means of method, arg1, arg2 and arg3.
 	 * If the interface and method is immutable, don't change anything.
 	 */
@@ -897,11 +897,11 @@
 			IPC_SET_ARG3(call->data, arg2);
 			
-			if (slow)
+			if (slow) {
 				IPC_SET_ARG4(call->data, arg3);
-			
-			/*
-			 * For system methods we deliberately don't
-			 * overwrite ARG5.
-			 */
+				/*
+				 * For system methods we deliberately don't
+				 * overwrite ARG5.
+				 */
+			}
 		} else {
 			IPC_SET_IMETHOD(call->data, imethod);
Index: kernel/generic/src/lib/ra.c
===================================================================
--- kernel/generic/src/lib/ra.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/generic/src/lib/ra.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -424,5 +424,5 @@
 void ra_init(void)
 {
-	ra_segment_cache = slab_cache_create("ra_segment_t",
+	ra_segment_cache = slab_cache_create("segment_cache",
 	    sizeof(ra_segment_t), 0, NULL, NULL, SLAB_CACHE_MAGDEFERRED);
 }
Index: kernel/generic/src/lib/rd.c
===================================================================
--- kernel/generic/src/lib/rd.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/generic/src/lib/rd.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -38,5 +38,4 @@
  */
 
-#include <print.h>
 #include <lib/rd.h>
 #include <mm/frame.h>
@@ -67,6 +66,4 @@
 	sysinfo_set_item_val("rd.size", NULL, size);
 	sysinfo_set_item_val("rd.address.physical", NULL, (sysarg_t) base);
-	
-	printf("RAM disk at %p (size %zu bytes)\n", (void *) base, size);
 }
 
Index: kernel/generic/src/main/kinit.c
===================================================================
--- kernel/generic/src/main/kinit.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/generic/src/main/kinit.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -116,8 +116,9 @@
 		 * Just a beautification.
 		 */
-		thread = thread_create(kmp, NULL, TASK,
-		    THREAD_FLAG_UNCOUNTED, "kmp");
+		thread = thread_create(kmp, NULL, TASK, THREAD_FLAG_WIRED, "kmp", true);
 		if (thread != NULL) {
-			thread_wire(thread, &cpus[0]);
+			irq_spinlock_lock(&thread->lock, false);
+			thread->cpu = &cpus[0];
+			irq_spinlock_unlock(&thread->lock, false);
 			thread_ready(thread);
 		} else
@@ -133,8 +134,9 @@
 		
 		for (i = 0; i < config.cpu_count; i++) {
-			thread = thread_create(kcpulb, NULL, TASK,
-			    THREAD_FLAG_UNCOUNTED, "kcpulb");
+			thread = thread_create(kcpulb, NULL, TASK, THREAD_FLAG_WIRED, "kcpulb", true);
 			if (thread != NULL) {
-				thread_wire(thread, &cpus[i]);
+				irq_spinlock_lock(&thread->lock, false);
+				thread->cpu = &cpus[i];
+				irq_spinlock_unlock(&thread->lock, false);
 				thread_ready(thread);
 			} else
@@ -150,6 +152,5 @@
 	
 	/* Start thread computing system load */
-	thread = thread_create(kload, NULL, TASK, THREAD_FLAG_NONE,
-	    "kload");
+	thread = thread_create(kload, NULL, TASK, 0, "kload", false);
 	if (thread != NULL)
 		thread_ready(thread);
@@ -162,6 +163,5 @@
 		 * Create kernel console.
 		 */
-		thread = thread_create(kconsole_thread, NULL, TASK,
-		    THREAD_FLAG_NONE, "kconsole");
+		thread = thread_create(kconsole_thread, NULL, TASK, 0, "kconsole", false);
 		if (thread != NULL)
 			thread_ready(thread);
@@ -201,5 +201,5 @@
 		str_cpy(namebuf + INIT_PREFIX_LEN,
 		    TASK_NAME_BUFLEN - INIT_PREFIX_LEN, name);
-		
+
 		/*
 		 * Create virtual memory mappings for init task images.
@@ -236,7 +236,5 @@
 			init_rd((void *) init.tasks[i].paddr, init.tasks[i].size);
 		} else
-			printf("init[%zu]: Init binary load failed "
-			    "(error %d, loader status %u)\n", i, rc,
-			    programs[i].loader_status);
+			printf("init[%zu]: Init binary load failed (error %d)\n", i, rc);
 	}
 	
Index: kernel/generic/src/main/main.c
===================================================================
--- kernel/generic/src/main/main.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/generic/src/main/main.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -276,6 +276,6 @@
 	 * Create the first thread.
 	 */
-	thread_t *kinit_thread = thread_create(kinit, NULL, kernel,
-	    THREAD_FLAG_UNCOUNTED, "kinit");
+	thread_t *kinit_thread =
+	    thread_create(kinit, NULL, kernel, 0, "kinit", true);
 	if (!kinit_thread)
 		panic("Cannot create kinit thread.");
Index: kernel/generic/src/main/uinit.c
===================================================================
--- kernel/generic/src/main/uinit.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/generic/src/main/uinit.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -56,4 +56,6 @@
 void uinit(void *arg)
 {
+	uspace_arg_t uarg;
+	
 	/*
 	 * So far, we don't have a use for joining userspace threads so we
@@ -70,17 +72,13 @@
 #endif
 	
-	uspace_arg_t *uarg = (uspace_arg_t *) arg;
-	uspace_arg_t local_uarg;
+	uarg.uspace_entry = ((uspace_arg_t *) arg)->uspace_entry;
+	uarg.uspace_stack = ((uspace_arg_t *) arg)->uspace_stack;
+	uarg.uspace_uarg = ((uspace_arg_t *) arg)->uspace_uarg;
+	uarg.uspace_thread_function = NULL;
+	uarg.uspace_thread_arg = NULL;
 	
-	local_uarg.uspace_entry = uarg->uspace_entry;
-	local_uarg.uspace_stack = uarg->uspace_stack;
-	local_uarg.uspace_stack_size = uarg->uspace_stack_size;
-	local_uarg.uspace_uarg = uarg->uspace_uarg;
-	local_uarg.uspace_thread_function = NULL;
-	local_uarg.uspace_thread_arg = NULL;
+	free((uspace_arg_t *) arg);
 	
-	free(uarg);
-	
-	userspace(&local_uarg);
+	userspace(&uarg);
 }
 
Index: kernel/generic/src/mm/as.c
===================================================================
--- kernel/generic/src/mm/as.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/generic/src/mm/as.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -130,5 +130,5 @@
 	as_arch_init();
 	
-	as_slab = slab_cache_create("as_t", sizeof(as_t), 0,
+	as_slab = slab_cache_create("as_slab", sizeof(as_t), 0,
 	    as_constructor, as_destructor, SLAB_CACHE_MAGDEFERRED);
 	
@@ -665,4 +665,10 @@
 		
 		page_table_lock(as, false);
+		
+		/*
+		 * Start TLB shootdown sequence.
+		 */
+		ipl_t ipl = tlb_shootdown_start(TLB_INVL_PAGES, as->asid,
+		    area->base + P2SZ(pages), area->pages - pages);
 		
 		/*
@@ -720,20 +726,4 @@
 				}
 				
-				/*
-				 * Start TLB shootdown sequence.
-				 *
-				 * The sequence is rather short and can be
-				 * repeated multiple times. The reason is that
-				 * we don't want to have used_space_remove()
-				 * inside the sequence as it may use a blocking
-				 * memory allocation for its B+tree. Blocking
-				 * while holding the tlblock spinlock is
-				 * forbidden and would hit a kernel assertion.
-				 */
-
-				ipl_t ipl = tlb_shootdown_start(TLB_INVL_PAGES,
-				    as->asid, area->base + P2SZ(pages),
-				    area->pages - pages);
-		
 				for (; i < size; i++) {
 					pte_t *pte = page_mapping_find(as,
@@ -753,23 +743,22 @@
 					page_mapping_remove(as, ptr + P2SZ(i));
 				}
-		
-				/*
-				 * Finish TLB shootdown sequence.
-				 */
-		
-				tlb_invalidate_pages(as->asid,
-				    area->base + P2SZ(pages),
-				    area->pages - pages);
-		
-				/*
-				 * Invalidate software translation caches
-				 * (e.g. TSB on sparc64, PHT on ppc32).
-				 */
-				as_invalidate_translation_cache(as,
-				    area->base + P2SZ(pages),
-				    area->pages - pages);
-				tlb_shootdown_finalize(ipl);
 			}
 		}
+		
+		/*
+		 * Finish TLB shootdown sequence.
+		 */
+		
+		tlb_invalidate_pages(as->asid, area->base + P2SZ(pages),
+		    area->pages - pages);
+		
+		/*
+		 * Invalidate software translation caches
+		 * (e.g. TSB on sparc64, PHT on ppc32).
+		 */
+		as_invalidate_translation_cache(as, area->base + P2SZ(pages),
+		    area->pages - pages);
+		tlb_shootdown_finalize(ipl);
+		
 		page_table_unlock(as, false);
 	} else {
Index: kernel/generic/src/mm/slab.c
===================================================================
--- kernel/generic/src/mm/slab.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/generic/src/mm/slab.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -891,5 +891,5 @@
 {
 	/* Initialize magazine cache */
-	_slab_cache_create(&mag_cache, "slab_magazine_t",
+	_slab_cache_create(&mag_cache, "slab_magazine",
 	    sizeof(slab_magazine_t) + SLAB_MAG_SIZE * sizeof(void*),
 	    sizeof(uintptr_t), NULL, NULL, SLAB_CACHE_NOMAGAZINE |
@@ -897,10 +897,10 @@
 	
 	/* Initialize slab_cache cache */
-	_slab_cache_create(&slab_cache_cache, "slab_cache_cache",
+	_slab_cache_create(&slab_cache_cache, "slab_cache",
 	    sizeof(slab_cache_cache), sizeof(uintptr_t), NULL, NULL,
 	    SLAB_CACHE_NOMAGAZINE | SLAB_CACHE_SLINSIDE);
 	
 	/* Initialize external slab cache */
-	slab_extern_cache = slab_cache_create("slab_t", sizeof(slab_t), 0,
+	slab_extern_cache = slab_cache_create("slab_extern", sizeof(slab_t), 0,
 	    NULL, NULL, SLAB_CACHE_SLINSIDE | SLAB_CACHE_MAGDEFERRED);
 	
Index: kernel/generic/src/mm/tlb.c
===================================================================
--- kernel/generic/src/mm/tlb.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/generic/src/mm/tlb.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -162,5 +162,5 @@
 	
 	size_t i;
-	for (i = 0; i < CPU->tlb_messages_count; i++) {
+	for (i = 0; i < CPU->tlb_messages_count; CPU->tlb_messages_count--) {
 		tlb_invalidate_type_t type = CPU->tlb_messages[i].type;
 		asid_t asid = CPU->tlb_messages[i].asid;
@@ -188,5 +188,4 @@
 	}
 	
-	CPU->tlb_messages_count = 0;
 	irq_spinlock_unlock(&CPU->lock, false);
 	CPU->tlb_active = true;
Index: kernel/generic/src/proc/program.c
===================================================================
--- kernel/generic/src/proc/program.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/generic/src/proc/program.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -71,5 +71,13 @@
 int program_create(as_t *as, uintptr_t entry_addr, char *name, program_t *prg)
 {
-	prg->loader_status = EE_OK;
+	uspace_arg_t *kernel_uarg;
+	
+	kernel_uarg = (uspace_arg_t *) malloc(sizeof(uspace_arg_t), 0);
+	kernel_uarg->uspace_entry = (void *) entry_addr;
+	kernel_uarg->uspace_stack = (void *) USTACK_ADDRESS;
+	kernel_uarg->uspace_thread_function = NULL;
+	kernel_uarg->uspace_thread_arg = NULL;
+	kernel_uarg->uspace_uarg = NULL;
+	
 	prg->task = task_create(as, name);
 	if (!prg->task)
@@ -83,18 +91,6 @@
 	    AS_AREA_READ | AS_AREA_WRITE | AS_AREA_CACHEABLE,
 	    STACK_SIZE, AS_AREA_ATTR_NONE, &anon_backend, NULL, &virt, 0);
-	if (!area) {
-		task_destroy(prg->task);
+	if (!area)
 		return ENOMEM;
-	}
-	
-	uspace_arg_t *kernel_uarg = (uspace_arg_t *)
-	    malloc(sizeof(uspace_arg_t), 0);
-	
-	kernel_uarg->uspace_entry = (void *) entry_addr;
-	kernel_uarg->uspace_stack = (void *) virt;
-	kernel_uarg->uspace_stack_size = STACK_SIZE;
-	kernel_uarg->uspace_thread_function = NULL;
-	kernel_uarg->uspace_thread_arg = NULL;
-	kernel_uarg->uspace_uarg = NULL;
 	
 	/*
@@ -102,11 +98,7 @@
 	 */
 	prg->main_thread = thread_create(uinit, kernel_uarg, prg->task,
-	    THREAD_FLAG_USPACE, "uinit");
-	if (!prg->main_thread) {
-		free(kernel_uarg);
-		as_area_destroy(as, virt);
-		task_destroy(prg->task);
+	    THREAD_FLAG_USPACE, "uinit", false);
+	if (!prg->main_thread)
 		return ELIMIT;
-	}
 	
 	return EOK;
@@ -119,10 +111,9 @@
  * executable image. The task is returned in *task.
  *
- * @param[in]  image_addr Address of an executable program image.
- * @param[in]  name       Name to set for the program's task.
- * @param[out] prg        Buffer for storing program info.
- *                        If image_addr points to a loader image,
- *                        prg->task will be set to NULL and EOK
- *                        will be returned.
+ * @param image_addr Address of an executable program image.
+ * @param name       Name to set for the program's task.
+ * @param prg        Buffer for storing program info. If image_addr
+ *                   points to a loader image, p->task will be set to
+ *                   NULL and EOK will be returned.
  *
  * @return EOK on success or negative error code.
@@ -135,11 +126,11 @@
 		return ENOMEM;
 	
-	prg->loader_status = elf_load((elf_header_t *) image_addr, as, 0);
-	if (prg->loader_status != EE_OK) {
+	unsigned int rc = elf_load((elf_header_t *) image_addr, as, 0);
+	if (rc != EE_OK) {
 		as_destroy(as);
 		prg->task = NULL;
 		prg->main_thread = NULL;
 		
-		if (prg->loader_status != EE_LOADER)
+		if (rc != EE_LOADER)
 			return ENOTSUP;
 		
@@ -149,5 +140,6 @@
 		
 		program_loader = image_addr;
-		printf("Program loader at %p\n", (void *) image_addr);
+		LOG("Registered program loader at %p",
+		    (void *) image_addr);
 		
 		return EOK;
@@ -179,10 +171,9 @@
 	}
 	
-	prg->loader_status = elf_load((elf_header_t *) program_loader, as,
+	unsigned int rc = elf_load((elf_header_t *) program_loader, as,
 	    ELD_F_LOADER);
-	if (prg->loader_status != EE_OK) {
+	if (rc != EE_OK) {
 		as_destroy(as);
-		printf("Cannot spawn loader (%s)\n",
-		    elf_error(prg->loader_status));
+		printf("Cannot spawn loader (%s)\n", elf_error(rc));
 		return ENOENT;
 	}
Index: kernel/generic/src/proc/scheduler.c
===================================================================
--- kernel/generic/src/proc/scheduler.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/generic/src/proc/scheduler.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -98,5 +98,5 @@
 	else {
 		fpu_init();
-		THREAD->fpu_context_exists = true;
+		THREAD->fpu_context_exists = 1;
 	}
 #endif
@@ -142,5 +142,5 @@
 		
 		/* Don't prevent migration */
-		CPU->fpu_owner->fpu_context_engaged = false;
+		CPU->fpu_owner->fpu_context_engaged = 0;
 		irq_spinlock_unlock(&CPU->fpu_owner->lock, false);
 		CPU->fpu_owner = NULL;
@@ -163,9 +163,9 @@
 		}
 		fpu_init();
-		THREAD->fpu_context_exists = true;
+		THREAD->fpu_context_exists = 1;
 	}
 	
 	CPU->fpu_owner = THREAD;
-	THREAD->fpu_context_engaged = true;
+	THREAD->fpu_context_engaged = 1;
 	irq_spinlock_unlock(&THREAD->lock, false);
 	
@@ -248,8 +248,8 @@
 		
 		/*
-		 * Clear the stolen flag so that it can be migrated
+		 * Clear the THREAD_FLAG_STOLEN flag so that t can be migrated
 		 * when load balancing needs emerge.
 		 */
-		thread->stolen = false;
+		thread->flags &= ~THREAD_FLAG_STOLEN;
 		irq_spinlock_unlock(&thread->lock, false);
 		
@@ -630,7 +630,8 @@
 				irq_spinlock_lock(&thread->lock, false);
 				
-				if ((!thread->wired) && (!thread->stolen) &&
-				    (!thread->nomigrate) &&
-				    (!thread->fpu_context_engaged)) {
+				if (!(thread->flags & THREAD_FLAG_WIRED) &&
+				    !(thread->flags & THREAD_FLAG_STOLEN) &&
+				    !thread->nomigrate &&
+				    !thread->fpu_context_engaged) {
 					/*
 					 * Remove thread from ready queue.
@@ -669,5 +670,5 @@
 #endif
 				
-				thread->stolen = true;
+				thread->flags |= THREAD_FLAG_STOLEN;
 				thread->state = Entering;
 				
Index: kernel/generic/src/proc/task.c
===================================================================
--- kernel/generic/src/proc/task.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/generic/src/proc/task.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -90,5 +90,5 @@
 	TASK = NULL;
 	avltree_create(&tasks_tree);
-	task_slab = slab_cache_create("task_t", sizeof(task_t), 0,
+	task_slab = slab_cache_create("task_slab", sizeof(task_t), 0,
 	    tsk_constructor, NULL, 0);
 }
Index: kernel/generic/src/proc/thread.c
===================================================================
--- kernel/generic/src/proc/thread.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/generic/src/proc/thread.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -191,5 +191,5 @@
 	kmflags |= FRAME_LOWMEM;
 	kmflags &= ~FRAME_HIGHMEM;
-	
+
 	thread->kstack = (uint8_t *) frame_alloc(STACK_FRAMES, FRAME_KA | kmflags);
 	if (!thread->kstack) {
@@ -236,10 +236,10 @@
 	
 	atomic_set(&nrdy, 0);
-	thread_slab = slab_cache_create("thread_t", sizeof(thread_t), 0,
+	thread_slab = slab_cache_create("thread_slab", sizeof(thread_t), 0,
 	    thr_constructor, thr_destructor, 0);
 	
 #ifdef CONFIG_FPU
-	fpu_context_slab = slab_cache_create("fpu_context_t",
-	    sizeof(fpu_context_t), FPU_CONTEXT_ALIGN, NULL, NULL, 0);
+	fpu_context_slab = slab_cache_create("fpu_slab", sizeof(fpu_context_t),
+	    FPU_CONTEXT_ALIGN, NULL, NULL, 0);
 #endif
 	
@@ -247,40 +247,25 @@
 }
 
-/** Wire thread to the given CPU
- *
- * @param cpu CPU to wire the thread to.
- *
- */
-void thread_wire(thread_t *thread, cpu_t *cpu)
+/** Make thread ready
+ *
+ * Switch thread to the ready state.
+ *
+ * @param thread Thread to make ready.
+ *
+ */
+void thread_ready(thread_t *thread)
 {
 	irq_spinlock_lock(&thread->lock, true);
-	thread->cpu = cpu;
-	thread->wired = true;
-	irq_spinlock_unlock(&thread->lock, true);
-}
-
-/** Make thread ready
- *
- * Switch thread to the ready state.
- *
- * @param thread Thread to make ready.
- *
- */
-void thread_ready(thread_t *thread)
-{
-	irq_spinlock_lock(&thread->lock, true);
 	
 	ASSERT(thread->state != Ready);
 	
-	int i = (thread->priority < RQ_COUNT - 1) ?
-	    ++thread->priority : thread->priority;
-	
-	cpu_t *cpu;
-	if (thread->wired || thread->nomigrate || thread->fpu_context_engaged) {
+	int i = (thread->priority < RQ_COUNT - 1)
+	    ? ++thread->priority : thread->priority;
+	
+	cpu_t *cpu = CPU;
+	if (thread->flags & THREAD_FLAG_WIRED) {
 		ASSERT(thread->cpu != NULL);
 		cpu = thread->cpu;
-	} else
-		cpu = CPU;
-	
+	}
 	thread->state = Ready;
 	
@@ -313,4 +298,6 @@
  * @param flags     Thread flags.
  * @param name      Symbolic name (a copy is made).
+ * @param uncounted Thread's accounting doesn't affect accumulated task
+ *                  accounting.
  *
  * @return New thread's structure on success, NULL on failure.
@@ -318,5 +305,5 @@
  */
 thread_t *thread_create(void (* func)(void *), void *arg, task_t *task,
-    thread_flags_t flags, const char *name)
+    unsigned int flags, const char *name, bool uncounted)
 {
 	thread_t *thread = (thread_t *) slab_alloc(thread_slab, 0);
@@ -348,13 +335,8 @@
 	thread->ucycles = 0;
 	thread->kcycles = 0;
-	thread->uncounted =
-	    ((flags & THREAD_FLAG_UNCOUNTED) == THREAD_FLAG_UNCOUNTED);
+	thread->uncounted = uncounted;
 	thread->priority = -1;          /* Start in rq[0] */
 	thread->cpu = NULL;
-	thread->wired = false;
-	thread->stolen = false;
-	thread->uspace =
-	    ((flags & THREAD_FLAG_USPACE) == THREAD_FLAG_USPACE);
-	
+	thread->flags = flags;
 	thread->nomigrate = 0;
 	thread->state = Entering;
@@ -374,6 +356,6 @@
 	thread->task = task;
 	
-	thread->fpu_context_exists = false;
-	thread->fpu_context_engaged = false;
+	thread->fpu_context_exists = 0;
+	thread->fpu_context_engaged = 0;
 	
 	avltree_node_initialize(&thread->threads_tree_node);
@@ -389,5 +371,5 @@
 	thread_create_arch(thread);
 	
-	if ((flags & THREAD_FLAG_NOATTACH) != THREAD_FLAG_NOATTACH)
+	if (!(flags & THREAD_FLAG_NOATTACH))
 		thread_attach(thread, task);
 	
@@ -455,5 +437,5 @@
 	
 	/* Must not count kbox thread into lifecount */
-	if (thread->uspace)
+	if (thread->flags & THREAD_FLAG_USPACE)
 		atomic_inc(&task->lifecount);
 	
@@ -477,9 +459,9 @@
 void thread_exit(void)
 {
-	if (THREAD->uspace) {
+	if (THREAD->flags & THREAD_FLAG_USPACE) {
 #ifdef CONFIG_UDEBUG
 		/* Generate udebug THREAD_E event */
 		udebug_thread_e_event();
-		
+
 		/*
 		 * This thread will not execute any code or system calls from
@@ -524,5 +506,5 @@
 {
 	ASSERT(THREAD);
-	
+
 	THREAD->nomigrate++;
 }
@@ -533,7 +515,6 @@
 	ASSERT(THREAD);
 	ASSERT(THREAD->nomigrate > 0);
-	
-	if (THREAD->nomigrate > 0)
-		THREAD->nomigrate--;
+
+	THREAD->nomigrate--;
 }
 
@@ -873,4 +854,5 @@
 	 * In case of failure, kernel_uarg will be deallocated in this function.
 	 * In case of success, kernel_uarg will be freed in uinit().
+	 *
 	 */
 	uspace_arg_t *kernel_uarg =
@@ -884,5 +866,5 @@
 	
 	thread_t *thread = thread_create(uinit, kernel_uarg, TASK,
-	    THREAD_FLAG_USPACE | THREAD_FLAG_NOATTACH, namebuf);
+	    THREAD_FLAG_USPACE | THREAD_FLAG_NOATTACH, namebuf, false);
 	if (thread) {
 		if (uspace_thread_id != NULL) {
Index: kernel/generic/src/synch/spinlock.c
===================================================================
--- kernel/generic/src/synch/spinlock.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/generic/src/synch/spinlock.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -262,5 +262,5 @@
 	int rc = spinlock_trylock(&(lock->lock));
 	
-	ASSERT_IRQ_SPINLOCK((!rc) || (!lock->guard), lock);
+	ASSERT_IRQ_SPINLOCK(!rc || !lock->guard, lock);
 	return rc;
 }
Index: kernel/generic/src/sysinfo/sysinfo.c
===================================================================
--- kernel/generic/src/sysinfo/sysinfo.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/generic/src/sysinfo/sysinfo.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -97,5 +97,5 @@
 void sysinfo_init(void)
 {
-	sysinfo_item_slab = slab_cache_create("sysinfo_item_t",
+	sysinfo_item_slab = slab_cache_create("sysinfo_item_slab",
 	    sizeof(sysinfo_item_t), 0, sysinfo_item_constructor,
 	    sysinfo_item_destructor, SLAB_CACHE_MAGDEFERRED);
Index: kernel/generic/src/udebug/udebug.c
===================================================================
--- kernel/generic/src/udebug/udebug.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/generic/src/udebug/udebug.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -410,7 +410,8 @@
 		
 		mutex_lock(&thread->udebug.lock);
+		unsigned int flags = thread->flags;
 		
 		/* Only process userspace threads. */
-		if (thread->uspace) {
+		if ((flags & THREAD_FLAG_USPACE) != 0) {
 			/* Prevent any further debug activity in thread. */
 			thread->udebug.active = false;
Index: kernel/generic/src/udebug/udebug_ops.c
===================================================================
--- kernel/generic/src/udebug/udebug_ops.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/generic/src/udebug/udebug_ops.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -95,5 +95,5 @@
 	
 	/* Verify that 'thread' is a userspace thread. */
-	if (!thread->uspace) {
+	if ((thread->flags & THREAD_FLAG_USPACE) == 0) {
 		/* It's not, deny its existence */
 		irq_spinlock_unlock(&thread->lock, true);
@@ -200,5 +200,5 @@
 		
 		mutex_lock(&thread->udebug.lock);
-		if (thread->uspace) {
+		if ((thread->flags & THREAD_FLAG_USPACE) != 0) {
 			thread->udebug.active = true;
 			mutex_unlock(&thread->udebug.lock);
@@ -393,9 +393,9 @@
 		
 		irq_spinlock_lock(&thread->lock, false);
-		bool uspace = thread->uspace;
+		int flags = thread->flags;
 		irq_spinlock_unlock(&thread->lock, false);
 		
 		/* Not interested in kernel threads. */
-		if (!uspace)
+		if ((flags & THREAD_FLAG_USPACE) == 0)
 			continue;
 		
Index: kernel/test/mm/falloc1.c
===================================================================
--- kernel/test/mm/falloc1.c	(revision b4ca0a9c7a4302dc4ff22c5f6fc9f5a94a0ee3b2)
+++ kernel/test/mm/falloc1.c	(revision a33706e404ea2be7e77e6260726d276e79b390f8)
@@ -37,31 +37,32 @@
 #include <align.h>
 
-#define MAX_FRAMES  1024U
+#define MAX_FRAMES  1024
 #define MAX_ORDER   8
 #define TEST_RUNS   2
 
-const char *test_falloc1(void)
-{
+const char *test_falloc1(void) {
+	uintptr_t *frames
+	    = (uintptr_t *) malloc(MAX_FRAMES * sizeof(uintptr_t), 0);
+	int results[MAX_ORDER + 1];
+	
+	int i, order, run;
+	int allocated;
+	
 	if (TEST_RUNS < 2)
 		return "Test is compiled with TEST_RUNS < 2";
 	
-	uintptr_t *frames = (uintptr_t *)
-	    malloc(MAX_FRAMES * sizeof(uintptr_t), 0);
 	if (frames == NULL)
 		return "Unable to allocate frames";
 	
-	unsigned int results[MAX_ORDER + 1];
-	for (unsigned int run = 0; run < TEST_RUNS; run++) {
-		for (unsigned int order = 0; order <= MAX_ORDER; order++) {
-			TPRINTF("Allocating %u frames blocks ... ", 1 << order);
+	for (run = 0; run < TEST_RUNS; run++) {
+		for (order = 0; order <= MAX_ORDER; order++) {
+			TPRINTF("Allocating %d frames blocks ... ", 1 << order);
 			
-			unsigned int allocated = 0;
-			for (unsigned int i = 0; i < (MAX_FRAMES >> order); i++) {
-				frames[allocated] = (uintptr_t)
-				    frame_alloc(order, FRAME_ATOMIC | FRAME_KA);
+			allocated = 0;
+			for (i = 0; i < MAX_FRAMES >> order; i++) {
+				frames[allocated] = (uintptr_t) frame_alloc(order, FRAME_ATOMIC | FRAME_KA);
 				
-				if (ALIGN_UP(frames[allocated], FRAME_SIZE << order) !=
-				    frames[allocated]) {
-					TPRINTF("Block at address %p (size %u) is not aligned\n",
+				if (ALIGN_UP(frames[allocated], FRAME_SIZE << order) != frames[allocated]) {
+					TPRINTF("Block at address %p (size %dK) is not aligned\n",
 					    (void *) frames[allocated], (FRAME_SIZE << order) >> 10);
 					return "Test failed";
@@ -86,5 +87,5 @@
 			TPRINTF("Deallocating ... ");
 			
-			for (unsigned int i = 0; i < allocated; i++)
+			for (i = 0; i < allocated; i++)
 				frame_free(KA2PA(frames[i]));
 			
